; path=GetDir() : char
; err=mkdir(path) : boolean
; err=rmdir(path) : boolean
; err=chdir(path) : boolean

PUBLIC GetDir
PUBLIC mkdir
PUBLIC rmdir
PUBLIC chdir

INCLUDE EXTENDA.MAC

len_path=80

DGROUP	GROUP	DATASG		; Combine your data segment
				; with Clipper's.
DATASG	SEGMENT	'_DATA'		; Start of data segment.

path	db	len_path dup(0)

DATASG	ENDS			; End of data segment.
;
_PROG	segment	'CODE'		; Start of code segment.
	ASSUME	cs:_PROG,ds:DGROUP
;
GetDir	PROC	FAR
	PushStack	<DS,SI>
	mov	AH, 19h
	int	21h
	add	AL, 'A'
	mov	path, AL
	mov	byte ptr path+1, ':'
	mov	byte ptr path+2, '\'
	mov	byte ptr path+3, 0
	push	DS
	mov	DX, SEG path
	mov	DS, DX
	mov	SI, offset path+3
	mov	DL, 00h
	mov	AH, 47h
	int	21h
	pop	DS
	cmp	byte ptr path+3, 0
	jnz	@m1
	mov	byte ptr path+2, 0
@m1:
	PopStack	<SI,DS>
	mov	DX, SEG path
	mov	AX, OFFSET path
	RET_CHAR	DX, AX
	ret
GetDir	ENDP
;
mkdir	PROC	FAR
	PushStack	<DS>
	GET_CHAR	1
	mov	DS, DX
	mov	DX, AX
	mov	AH, 39h
	int	21h
	mov	AX, TRUE
	jnc	@@IF_mkdir
	mov	AX, FALSE
@@IF_mkdir:
	PopStack	<DS>
	RET_LOGICAL	AX
	ret
mkdir	ENDP
;
rmdir	PROC	FAR
	PushStack	<DS>
	GET_CHAR	1
	mov	DS, DX
	mov	DX, AX
	mov	AH, 3Ah
	int	21h
	mov	AX, TRUE
	jnc	@@IF_rmdir
	mov	AX, FALSE
@@IF_rmdir:
	PopStack	<DS>
	RET_LOGICAL	AX
	ret
rmdir	ENDP
;
chdir	PROC	FAR
	PushStack	<DS>
	GET_CHAR	1
	mov	DS, DX
	mov	DX, AX
	mov	AH, 3Bh
	int	21h
	mov	AX, TRUE
	jnc	@@IF_chdir
	mov	AX, FALSE
@@IF_chdir:
	PopStack	<DS>
	RET_LOGICAL	AX
	ret
chdir	ENDP
;
_PROG	ENDS
	END
