; LINE.ASM

; LoadLine(Lines,len_prn) : void
; LoadPos(Lines,pos) : void
; string=NextLine() : char
; is_str=IsStr() : logical
; is_lin=IsLin() : logical

PUBLIC LoadLine
PUBLIC LoadPos
PUBLIC NextLine
PUBLIC IsStr
PUBLIC IsLin

INCLUDE EXTENDA.MAC

len_line=255
EOLN	=0A0Dh

DGROUP	GROUP	DATASG		; Combine your data segment
				; with Clipper's.
DATASG	SEGMENT	'_DATA'		; Start of data segment.

lines	dd	0
pos	dw	0
len_prn	dw	0
line	db	len_line dup(0)
is_str	dw	TRUE
is_lin	dw	TRUE

DATASG	ENDS			; End of data segment.
;
_PROG	segment	'CODE'		; Start of code segment.
	ASSUME	cs:_PROG,ds:DGROUP
;
LoadLine	PROC	FAR
	GET_CHAR	1
	mov	word ptr lines+2, DX
	mov	word ptr lines, AX
	GET_INT		2
	mov	len_prn, AX
	mov	is_str, TRUE
	RET_VOID
	ret
LoadLine	ENDP
;
LoadPos	PROC	FAR
	GET_CHAR	1
	mov	word ptr lines+2, DX
	mov	word ptr lines, AX
	GET_INT		2
	dec	AX
	mov	pos, AX
	mov	is_str, FALSE
	mov	is_lin, TRUE
	RET_VOID
	ret
LoadPos	ENDP
;
IsStr	PROC	FAR
	mov	AX, is_str
	RET_LOGICAL	AX
	ret
IsStr	ENDP
;
IsLin	PROC	FAR
	mov	AX, is_lin
	RET_LOGICAL	AX
	ret
IsLin	ENDP
;
NextLine	PROC	FAR
	PushStack	<DS,ES,DI,SI>
	les	SI, lines
	xor	DI, DI
	mov	AL, ES:[SI]
	cmp	AL, 0
	jne	@endif1
	 mov	is_lin, FALSE
	 jmp	@exit	
	@endif1:
	;  pos
	mov	BX, pos
	xor	DX, DX
	@repeat1:
	 mov	AX, ES:[SI]
	 cmp	AX, EOLN
	 jne	@endif2
	 mov	word ptr line[DI], AX
	 add	DI, 2
	 add	SI, 2
	 jmp	@exit	
	@endif2:
	cmp	AL, 0
	jne	@endif3
	 mov	is_lin, FALSE
	 jmp	@exit	
	@endif3:
	cmp	DX, BX
	je	@until1
	 inc	SI
	 inc	DX
	 jmp	@repeat1
	@until1:
	;  
	mov	CX, len_prn
	xor	DX, DX
	@repeat2:
	 mov	AX, ES:[SI]
	 cmp	AX, EOLN
	 jne	@endif4
	 mov	word ptr line[DI], AX
	 add	DI, 2
	 add	SI, 2
	 jmp	@exit	
	@endif4:
	cmp	AL, 0
	jne	@endif6
	mov	is_lin, FALSE
	jmp	@exit
	@endif6:
	mov	line[DI], AL
	inc	DI
	inc	SI
	cmp	DX, CX
	je	@until2
	 inc	DX
	 jmp	@repeat2
	@until2:
	mov	is_str, TRUE
	;   ப
	@repeat3:
	 mov	AX, ES:[SI]
	 cmp	AX, EOLN
	 jne	@endif5
	 mov	word ptr line[DI], AX
	 add	DI, 2
	 add	SI, 2
	 jmp	@exit	
	@endif5:
	cmp	AL, 0
	jne	@endif7
	mov	is_lin, FALSE
	jmp	@exit
	@endif7:
	inc	SI
	jmp	@repeat3
	; 室
	@exit:
	mov	line[DI], 0
	mov	word ptr lines, SI
	PopStack	<SI,DI,ES,DS>
	mov	DX, SEG line
	mov	AX, OFFSET line
	RET_CHAR	DX, AX
	ret
NextLine	ENDP
;
_PROG	ENDS
	END
